package processo;

import officina.*;
import _framework.Executor;
import gui.Attesa;
import gui.AttivitaIO;
import gui.RecordPratica;



public class SottoramoPersonale implements Runnable{
	private boolean eseguita=false;
	private Riparazione pratica;

	public SottoramoPersonale(Riparazione riparazione) 
	{
		this.pratica=riparazione;
	}
	
	public synchronized void run() 
	{
		if (eseguita)
			return;
		eseguita=true;
		
		AttivitaIO.aspetta(new Attesa<Riparazione>("Richiesta supporto",pratica));
		boolean richiesta = AttivitaIO.verificaRichiestaSupporto();		
		
		if (richiesta){// il supporto  stato richiesto
			AttivitaRichiestaPersonale acrp = new AttivitaRichiestaPersonale(pratica);
			acrp.run();
		}
	}
}
